Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 129042)
+++ channels/chan_sip.c	(working copy)
@@ -1756,7 +1756,7 @@
 /*! \brief The real destination address for a write */
 static const struct sockaddr_in *sip_real_dst(const struct sip_pvt *p)
 {
-	return ast_test_flag(&p->flags[0], SIP_NAT) & SIP_NAT_ROUTE ? &p->recv : &p->sa;
+	return &p->recv;
 }
 
 /*! \brief Display SIP nat mode */
@@ -5734,7 +5734,7 @@
 			break;
 
 		if (!copied) {	/* Only check for empty rport in topmost via header */
-			char leftmost[512], *others, *rport;
+			char leftmost[512], *others, *rport, *dest;
 
 			/* Only work on leftmost value */
 			ast_copy_string(leftmost, oh, sizeof(leftmost));
@@ -5742,6 +5742,13 @@
 			if (others)
 			    *others++ = '\0';
 
+			dest = strchr(leftmost, ';');
+			if (dest && ((ast_test_flag(&p->flags[0], SIP_NAT) == SIP_NAT_ALWAYS) || (ast_test_flag(&p->flags[0], SIP_NAT) == SIP_NAT_RFC3581))) {
+				char buf[512];
+				snprintf(buf, sizeof(buf), "SIP/2.0/UDP %s:%d%s", ast_inet_ntoa(p->recv.sin_addr), ntohs(p->recv.sin_port), dest); 
+				ast_copy_string(leftmost, buf, sizeof(leftmost));
+			}
+
 			/* Find ;rport;  (empty request) */
 			rport = strstr(leftmost, ";rport");
 			if (rport && *(rport+6) == '=') 
